﻿<?php
/**
 * @version		1.5.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined('_JEXEC') or die();

class os_robokassa extends os_payment
{

	/**
	 * robokassa mode 
	 *
	 * @var boolean live mode : true, test mode : false
	 */
	var $_mode = 0;

	/**
	 * robokassa url
	 *
	 * @var string
	 */
	var $_url = null;

	/**
	 * Array of params will be posted to server
	 *
	 * @var string
	 */
	var $_params = array();

	/**
	 * Array containing data posted from robokassa to our server
	 *
	 * @var array
	 */
	var $_data = array();
	
	// регистрационная информация (логин, пароль #1)
	// registration info (login, password #1)
	var $mrh_login = "";
	var $mrh_pass1 = "";
	var $mrh_pass2 = "";
	
	// номер заказа
	// number of order
	var $inv_id = 0;
	
	// описание заказа
	// order description
	var $inv_desc = "Оплата через robokassa";
	
	// сумма заказа
	// sum of order
	var $out_summ = "8.96";
	
	// номер события
	// number of event
	var $shp_item = 0;
	
	// предлагаемая валюта платежа
	// default payment e-currency
	var $in_curr = "";
	
	// язык
	// language
	var $culture = "ru";
	
	// формирование подписи
	// generate signature
	var $crc  = 'RUB';
	
	function sing($mrh_login,$out_summ,$inv_id,$mrh_pass1,$shp_item){
		return  md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1:Shp_item=$shp_item");	
	}

	/**
	 * Constructor functions, init some parameter
	 *
	 * @param object $config
	 */
	function os_robokassa($params)
	{
		parent::setName('os_robokassa');
		parent::os_payment();
		parent::setCreditCard(false);
		parent::setCardType(false);
		parent::setCardCvv(false);
		parent::setCardHolderName(false);
		$this->ipn_log = true;
		$this->ipn_log_file = JPATH_COMPONENT . '/ipn_logs.txt';
		$this->_mode = $params->get('robokassa_mode');
		if ($this->_mode){
			$this->_url = 'https://merchant.roboxchange.com/Index.aspx';
		}else{
			$this->_url = 'http://test.robokassa.ru/Index.aspx';
		}
		$this->mrh_login = $params->get('robokassa_login');
		$this->mrh_pass1 = $params->get('robokassa_password1');
		$this->mrh_pass2 = $params->get('robokassa_password2');
		$this->setParam('MrchLogin', $params->get('robokassa_login'));
		$this->setParam('Culture', $this->culture);
		//$this->setParam('IncCurrLabel', $params->get('robokassa_currency', 'RUB'));
		$this->setParam('IncCurrLabel', '');

	}

	/**
	 * Set param value
	 *
	 * @param string $name
	 * @param string $val
	 */
	function setParam($name, $val)
	{
		$this->_params[$name] = $val;
	}

	/**
	 * Setup payment parameter
	 *
	 * @param array $params
	 */
	function setParams($params)
	{
		foreach ($params as $key => $value)
		{
			$this->_params[$key] = $value;
		}
	}

	/**
	 * Process Payment
	 *
	 * @param object $row
	 * @param array $params
	 */
	function processPayment($row, $data)
	{
//echo "<pre>".print_r($row,true)."</pre>";	die();	
		$Itemid = JRequest::getInt('Itemid');

		$siteUrl = JURI::base();
		$db = JFactory::getDBO();
/*		$sql = 'SELECT robokassa_email FROM #__eb_events WHERE id=' . $row->event_id;
		$db->setQuery($sql);
		$robokassaEmail = $db->loadResult();
		if (strlen(trim($robokassaEmail)))
		{
			$this->setParam('business', $robokassaEmail);
		}*/
		$itemName = JText::_('EB_EVENT_REGISTRATION');
		$itemName = str_replace('[EVENT_TITLE]', $data['event_title'], $itemName);
		
		$sql = 'SELECT currency_code FROM #__eb_events WHERE id=' . $row->event_id;
		$db->setQuery($sql);
		$currencyCode = $db->loadResult();
		if ($currencyCode)
		{
			$this->setParam('IncCurrLabel', $currencyCode);
		}
		
		var_dump($this->mrh_login);
		$this->mrh_login = iconv('ASCII', 'UTF-8', $this->mrh_login);
		echo mb_detect_encoding($this->mrh_login);
		
		$OutSum = round($data['amount'], 2);
		var_dump($OutSum);
		echo mb_detect_encoding($OutSum);
		var_dump($row->id);
		echo mb_detect_encoding($row->id);
		var_dump($this->mrh_pass1);
		echo mb_detect_encoding($this->mrh_pass1);
		var_dump($row->event_id);
		echo mb_detect_encoding($row->event_id);
		$sing =$this->sing($this->mrh_login,$OutSum,$row->id,$this->mrh_pass1,$row->event_id);
		echo mb_detect_encoding($sing);
		$Signature = iconv('ASCII', 'UTF-8', $sing);
		var_dump($Signature);
		echo mb_detect_encoding($str);//die();
		$this->setParam('item_name', $itemName);
		$this->setParam('inv_id', $row->id);
		$this->setParam('OutSum',$OutSum );
		$this->setParam('shp_item', $row->event_id);
		$this->setParam('Desc', 'Оплата за участие в событии №'.$row->event_id);
		$this->setParam('SignatureValue', $Signature);
		$this->submitPost();
	}
	
	/**
	 * Submit post to robokassa server
	 *
	 */
	function submitPost() {
	?>
		<div class="contentheading"><?php echo  JText::_('EB_WAIT_ROBOKASSA'); ?></div>
		<form method="post" action="<?php echo $this->_url; ?>" name="jd_form" id="jd_form">
			<?php
				foreach ($this->_params as $key=>$val) {
					echo '<input type="hidden" name="'.$key.'" value="'.$val.'" />';
					echo "\n";	
				}
			?>
<!--			<script type="text/javascript">
				function redirect() {
					document.jd_form.submit();
				}
				setTimeout('redirect()',5000);
			</script>-->
		</form>
	<?php	
	}
	
	/**
	 * Validate the post data from robokassa to our server
	 *
	 * @return string
	 */
	function _validate()
	{
		$errNum = "";
		$errStr = "";
		$urlParsed = parse_url($this->_url);
		$host = $urlParsed['host'];
		$path = $urlParsed['path'];
		$postString = '';
		$response = '';
		foreach ($_POST as $key => $value)
		{
			$this->_data[$key] = $value;
			$postString .= $key . '=' . urlencode(stripslashes($value)) . '&';
		}
		$postString .= 'cmd=_notify-validate';
		$fp = fsockopen($host, '80', $errNum, $errStr, 30);
		if (!$fp)
		{
			return false;
		}
		else
		{
			fputs($fp, "POST $path HTTP/1.1\r\n");
			fputs($fp, "Host: $host\r\n");
			fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
			fputs($fp, "Content-length: " . strlen($postString) . "\r\n");
			fputs($fp, "Connection: close\r\n\r\n");
			fputs($fp, $postString . "\r\n\r\n");
			while (!feof($fp))
			{
				$response .= fgets($fp, 1024);
			}
			fclose($fp);
		}
		$this->ipn_response = $response;
		$this->log_ipn_results(true);
		if ($this->_mode)
		{
			if (eregi("VERIFIED", $response) && ($this->_data['payment_status'] == 'Completed'))
				return true;
			else
				return false;
		}
		else
		{
			return true; //Always return true on testing to avoid bug from robokassa
			/*if ($this->_data['payment_status'] == 'Completed')
	             return true ;
	         else 
	             return false ;
	          */
		}
	}

	/**
	 * Log IPN result
	 *
	 * @param string $success
	 */
	function log_ipn_results($success)
	{
		if (!$this->ipn_log)
			return;
		$text = '[' . date('m/d/Y g:i A') . '] - ';
		if ($success)
			$text .= "SUCCESS!\n";
		else
			$text .= 'FAIL: ' . $this->last_error . "\n";
		$text .= "IPN POST Vars from robokassa:\n";
		foreach ($this->_data as $key => $value)
		{
			$text .= "$key=$value, ";
		}
		$text .= "\nIPN Response from robokassa Server:\n " . $this->ipn_response;
		$fp = fopen($this->ipn_log_file, 'a');
		fwrite($fp, $text . "\n\n");
		fclose($fp); // close file
	}

	/**
	 * Process payment 
	 *
	 */
	function verifyPayment()
	{
		$ret = $this->_validate();
		if ($ret)
		{
			$config = EventBookingHelper::getConfig();
			$id = $this->_data['custom'];
			$transactionId = $this->_data['txn_id'];
			$amount = $this->_data['mc_gross'];
			if ($amount < 0)
				return false;
			$row = JTable::getInstance('EventBooking', 'Registrant');
			$row->load($id);
			if (!$row->id)
				return false;
			if ($row->published)
				return false;
			$row->transaction_id = $transactionId;
			$row->payment_date = date('Y-m-d H:i:s');
			$row->published = true;
			$row->store();
			if ($row->is_group_billing)
			{
				EventBookingHelper::updateGroupRegistrationRecord($row->id);
			}
			EventBookingHelper::sendEmails($row, $config);
			JPluginHelper::importPlugin('eventbooking');
			$dispatcher = JDispatcher::getInstance();
			$dispatcher->trigger('onAfterPaymentSuccess', array($row));
			return true;
		}
		else
		{
			return false;
		}
	}
}